﻿-- Frame control module

function SN:UnlockFrame(frame)
	if frame.frameLocked == 1 then
		frame:SetBackdrop( { bgFile   = "Interface/Tooltips/UI-Tooltip-Background",
							edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
							tile     = false,
							tileSize = 0,
							edgeSize = 2,
							insets = { left = 0, right = 0, top = 0, bottom = 0 }
						} )
		frame:SetBackdropColor(.1, .1, .1, .8)
		frame:SetBackdropBorderColor(.1, .1, .1, .5)
			
		frame.value:SetText("Move")
			
		frame.t = frame:CreateTexture("ARTWORK")
		frame.t:SetPoint("TOPLEFT", frame, "TOPLEFT", 1, -1)
		frame.t:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -1, -19)
		frame.t:SetHeight(20)
		frame.t:SetTexture(.5, .5, .5)
		frame.t:SetAlpha(.3)

		frame.d = frame:CreateTexture("ARTWORK")
		frame.d:SetHeight(16)
		frame.d:SetWidth(16)
		frame.d:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -1, 1)
		frame.d:SetTexture(.5, .5, .5)
		frame.d:SetAlpha(.3)

		frame.tr = frame:CreateTitleRegion()
		frame.tr:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, 0)
		frame.tr:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0)
		frame.tr:SetHeight(21)

		frame:EnableMouse(true)
		frame:SetMovable(true)
		frame:RegisterForDrag("LeftButton")

		frame.frameLocked = 0
	end
end

function SN:LockFrame(frame)
	local v

	if frame == SN.F.threat then
		v = SN.db.profile.Frames.threat
	elseif frame == SN.F.debuffs then
		if(IsAddOnLoaded("ElvUI")) then
			v = SN.db.profile.Frames.elvdebuffs
		else
			v = SN.db.profile.Frames.debuffs
		end
	elseif frame == SN.F.cooldowns then
		if(IsAddOnLoaded("ElvUI")) then
			v = SN.db.profile.Frames.elvcooldowns
		else
			v = SN.db.profile.Frames.cooldowns
		end
	elseif frame == SN.F.powercontainer then
		v = SN.db.profile.Frames.power
	end

	if frame.frameLocked == 0 then
		frame:SetBackdrop(nil)
		frame.t:Hide()
		frame.t = nil
		frame.d:Hide()
		frame.d = nil
		frame.tr = nil
		frame:EnableMouse(false)
		frame:SetMovable(false)
		frame.value:SetText("")
		
		v[1], v[2], v[3], v[4] = frame:GetPoint()

		-- sweep up
		collectgarbage()

		frame.frameLocked = 1
	end
end

function SN:MoveFrames(settings)
	
	--local frames = { SN.F.threat, SN.F.debuffs, SN.F.cooldowns, SN.F.powercontainer }
	if settings then
		for i, frame in pairs(SN.F) do
			SN:LockFrame(SN.F[i])
		end
		SN.db.profile.Frames.lock = true
	else
		for i, frame in pairs(SN.F) do
			SN:UnlockFrame(SN.F[i])
		end
		SN.db.profile.Frames.lock = false
	end
end

function SN:SNCreateBG(frame)
	
	--Make the frames look like ElvUI
	if(IsAddOnLoaded("ElvUI")) then
		local bg = CreateFrame("Frame")
		bg:SetTemplate("Default")
		bg:SetParent(frame)
		bg:ClearAllPoints()
		bg:Point("TOPLEFT", frame, "TOPLEFT", -2, 2)
		bg:Point("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 2, -2)
		bg:SetFrameStrata("LOW")
		bg:Show()
	end
end

function ResetAnchors()
	local static = SN.V.defaults.profile.Frames
	local temp = SN.db.profile.Frames

	local f = SN.F
	
	for i, frame in pairs(SN.F) do
		frame:ClearAllPoints()
	end

	if (IsAddOnLoaded("ElvUI")) then
		f.debuffs:SetPoint(unpack(static.elvdebuffs))
		f.cooldowns:SetPoint(unpack(static.elvcooldowns))
		wipe(temp.elvdebuffs)
		wipe(temp.elvcooldowns)
	else
		f.debuffs:SetPoint(unpack(static.debuffs))
		f.cooldowns:SetPoint(unpack(static.cooldowns))
		wipe(temp.debuffs)
		wipe(temp.cooldowns)
	end
	f.threat:SetPoint(unpack(static.threat))
	f.powercontainer:SetPoint(unpack(static.power))
	wipe(temp.threat)
	wipe(temp.power)
	ReloadUI()
end